# CfnDataSource

Creates a data source connector for an Amazon Q Business application.

`CreateDataSource` is a synchronous operation. The operation returns 200 if the data source was successfully created. Otherwise, an exception is raised.

Extends: Construct › CfnElement › CfnRefElement › CfnResource › CfnDataSource
Implements: IInspectable, ITaggableV2, IEnvironmentAware, IDataSourceRef, IConstruct, IDependable

- CloudFormation: [`AWS::QBusiness::DataSource`](https://docs.aws.amazon.com/AWSCloudFormation/latest/TemplateReference/aws-resource-qbusiness-datasource.html)
- Source: Generated code
- Type last changed: v2.252.0 · 30 Apr 2026

## Example

```ts
// The code below shows an example of how to instantiate this type.
// The values are placeholders you should change.
import { aws_qbusiness as qbusiness } from 'aws-cdk-lib';

declare const configuration: any;
const cfnDataSource = new qbusiness.CfnDataSource(this, 'MyCfnDataSource', {
  applicationId: 'applicationId',
  configuration: configuration,
  displayName: 'displayName',
  indexId: 'indexId',

  // the properties below are optional
  description: 'description',
  documentEnrichmentConfiguration: {
    inlineConfigurations: [{
      condition: {
        key: 'key',
        operator: 'operator',

        // the properties below are optional
        value: {
          dateValue: 'dateValue',
          longValue: 123,
          stringListValue: ['stringListValue'],
          stringValue: 'stringValue',
        },
      },
      documentContentOperator: 'documentContentOperator',
      target: {
        key: 'key',

        // the properties below are optional
        attributeValueOperator: 'attributeValueOperator',
        value: {
          dateValue: 'dateValue',
          longValue: 123,
          stringListValue: ['stringListValue'],
          stringValue: 'stringValue',
        },
      },
    }],
    postExtractionHookConfiguration: {
      invocationCondition: {
        key: 'key',
        operator: 'operator',

        // the properties below are optional
        value: {
          dateValue: 'dateValue',
          longValue: 123,
          stringListValue: ['stringListValue'],
          stringValue: 'stringValue',
        },
      },
      lambdaArn: 'lambdaArn',
      roleArn: 'roleArn',
      s3BucketName: 's3BucketName',
    },
    preExtractionHookConfiguration: {
      invocationCondition: {
        key: 'key',
        operator: 'operator',

        // the properties below are optional
        value: {
          dateValue: 'dateValue',
          longValue: 123,
          stringListValue: ['stringListValue'],
          stringValue: 'stringValue',
        },
      },
      lambdaArn: 'lambdaArn',
      roleArn: 'roleArn',
      s3BucketName: 's3BucketName',
    },
  },
  mediaExtractionConfiguration: {
    audioExtractionConfiguration: {
      audioExtractionStatus: 'audioExtractionStatus',
    },
    imageExtractionConfiguration: {
      imageExtractionStatus: 'imageExtractionStatus',
    },
    videoExtractionConfiguration: {
      videoExtractionStatus: 'videoExtractionStatus',
    },
  },
  roleArn: 'roleArn',
  syncSchedule: 'syncSchedule',
  tags: [{
    key: 'key',
    value: 'value',
  }],
  vpcConfiguration: {
    securityGroupIds: ['securityGroupIds'],
    subnetIds: ['subnetIds'],
  },
});
```

## Initializer

```ts
new CfnDataSource(scope: Construct, id: string, props: CfnDataSourceProps)
```

## Construct Props

- `applicationId`: string (required) — The identifier of the Amazon Q Business application the data source will be attached to.

- `configuration`: any (required) — Use this property to specify a JSON or YAML schema with configuration properties specific to your data source connector to connect your data source repository to Amazon Q Business .

  You must use the JSON or YAML schema provided by Amazon Q .

  The following links have the configuration properties and schemas for AWS CloudFormation for the following connectors:

  - [Amazon Simple Storage Service](https://docs.aws.amazon.com/amazonq/latest/qbusiness-ug/s3-cfn.html)
  - [Amazon Q Web Crawler](https://docs.aws.amazon.com/amazonq/latest/qbusiness-ug/web-crawler-cfn.html)

  Similarly, you can find configuration templates and properties for your specific data source using the following steps:

  - Navigate to the [Supported connectors](https://docs.aws.amazon.com/amazonq/latest/business-use-dg/connectors-list.html) page in the Amazon Q Business User Guide, and select the data source connector of your choice.
  - Then, from that specific data source connector's page, choose the topic containing *Using CloudFormation* to find the schemas for your data source connector, including configuration parameter descriptions and examples.

- `description`: string — A description for the data source connector.

- `displayName`: string (required) — The name of the Amazon Q Business data source.

- `documentEnrichmentConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSource.DocumentEnrichmentConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_qbusiness.CfnDataSource.DocumentEnrichmentConfigurationProperty.html) — Provides the configuration information for altering document metadata and content during the document ingestion process.

  For more information, see [Custom document enrichment](https://docs.aws.amazon.com/amazonq/latest/business-use-dg/custom-document-enrichment.html) .

- `indexId`: string (required) — The identifier of the index the data source is attached to.

- `mediaExtractionConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSource.MediaExtractionConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_qbusiness.CfnDataSource.MediaExtractionConfigurationProperty.html) — The configuration for extracting information from media in documents.

- `roleArn`: string — The Amazon Resource Name (ARN) of an IAM role with permission to access the data source and required resources.

  This field is required for all connector types except custom connectors, where it is optional.

- `syncSchedule`: string — Sets the frequency for Amazon Q Business to check the documents in your data source repository and update your index.

  If you don't set a schedule, Amazon Q Business won't periodically update the index.

  Specify a `cron-` format schedule string or an empty string to indicate that the index is updated on demand. You can't specify the `Schedule` parameter when the `Type` parameter is set to `CUSTOM` . If you do, you receive a `ValidationException` exception.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of key-value pairs that identify or categorize the data source connector.

  You can also use tags to help control access to the data source connector. Tag keys and values can consist of Unicode letters, digits, white space, and any of the following symbols: _ . : / = + -

- `vpcConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSource.DataSourceVpcConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_qbusiness.CfnDataSource.DataSourceVpcConfigurationProperty.html) — Configuration information for an Amazon VPC (Virtual Private Cloud) to connect to your data source.

  For more information, see [Using Amazon VPC with Amazon Q Business connectors](https://docs.aws.amazon.com/amazonq/latest/business-use-dg/connector-vpc.html) .

## Properties

- `applicationId`: string — The identifier of the Amazon Q Business application the data source will be attached to.

- `attrCreatedAt`: string — The Unix timestamp when the Amazon Q Business data source was created.

- `attrDataSourceArn`: string — The Amazon Resource Name (ARN) of a data source in an Amazon Q Business application.

- `attrDataSourceId`: string — The identifier of the Amazon Q Business data source.

- `attrStatus`: string — The status of the Amazon Q Business data source.

- `attrType`: string — The type of the Amazon Q Business data source.

- `attrUpdatedAt`: string — The Unix timestamp when the Amazon Q Business data source was last updated.

- `cdkTagManager`: [TagManager](/cdk/api/v2/docs/aws-cdk-lib.TagManager.html) — Tag Manager which manages the tags for this resource.

- `CFN_RESOURCE_TYPE_NAME`: string (static) — The CloudFormation resource type name for this resource class.

- `cfnOptions`: [ICfnResourceOptions](/cdk/api/v2/docs/aws-cdk-lib.ICfnResourceOptions.html) — Options for this resource, such as condition, update policy etc.

- `cfnResourceType`: string — AWS resource type.

- `configuration`: any — Use this property to specify a JSON or YAML schema with configuration properties specific to your data source connector to connect your data source repository to Amazon Q Business .

- `creationStack`: string[]

- `dataSourceRef`: [DataSourceReference](/cdk/api/v2/docs/aws-cdk-lib.interfaces.aws_qbusiness.DataSourceReference.html) — A reference to a DataSource resource.

- `description`: string — A description for the data source connector.

- `displayName`: string — The name of the Amazon Q Business data source.

- `documentEnrichmentConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSource.DocumentEnrichmentConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_qbusiness.CfnDataSource.DocumentEnrichmentConfigurationProperty.html) — Provides the configuration information for altering document metadata and content during the document ingestion process.

- `env`: [ResourceEnvironment](/cdk/api/v2/docs/aws-cdk-lib.interfaces.ResourceEnvironment.html)

- `indexId`: string — The identifier of the index the data source is attached to.

- `logicalId`: string — The logical ID for this CloudFormation stack element.

  The logical ID of the element
  is calculated from the path of the resource node in the construct tree.

  To override this value, use `overrideLogicalId(newLogicalId)`.

- `mediaExtractionConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSource.MediaExtractionConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_qbusiness.CfnDataSource.MediaExtractionConfigurationProperty.html) — The configuration for extracting information from media in documents.

- `node`: [Node](/cdk/api/v2/docs/constructs.Node.html) — The tree node.

- `ref`: string — Return a string that will be resolved to a CloudFormation `{ Ref }` for this element.

  If, by any chance, the intrinsic reference of a resource is not a string, you could
  coerce it to an IResolvable through `Lazy.any({ produce: resource.ref })`.

- `roleArn`: string — The Amazon Resource Name (ARN) of an IAM role with permission to access the data source and required resources.

- `stack`: [Stack](/cdk/api/v2/docs/aws-cdk-lib.Stack.html) — The stack in which this element is defined.

  CfnElements must be defined within a stack scope (directly or indirectly).

- `syncSchedule`: string — Sets the frequency for Amazon Q Business to check the documents in your data source repository and update your index.

- `tags`: [CfnTag](/cdk/api/v2/docs/aws-cdk-lib.CfnTag.html)[] — A list of key-value pairs that identify or categorize the data source connector.

- `vpcConfiguration`: [IResolvable](/cdk/api/v2/docs/aws-cdk-lib.IResolvable.html) | [CfnDataSource.DataSourceVpcConfigurationProperty](/cdk/api/v2/docs/aws-cdk-lib.aws_qbusiness.CfnDataSource.DataSourceVpcConfigurationProperty.html) — Configuration information for an Amazon VPC (Virtual Private Cloud) to connect to your data source.

## Methods

- `addDeletionOverride(path: string): void` — Syntactic sugar for `addOverride(path, undefined)`.

  **Parameters**

  - `path` — The path of the value to delete.

- `addDependency(target: CfnResource): void` — Use `addResourceDependency` instead.

  This method has been renamed to `addResourceDependency` to more clearly
  set it apart from `construct.node.addDependency`. See the documentation
  of that function for more details.

- `addDependsOn(target: CfnResource): void` — Use `addResourceDependency` instead.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method has been renamed to `addResourceDependency`, which makes it
  more clear that this method operates at a different level from the
  construct-level `construct.node.addDependency()` mechanism.

- `addMetadata(key: string, value: any): void` — Add a value to the CloudFormation Resource Metadata.

- `addOverride(path: string, value: any): void` — Adds an override to the synthesized CloudFormation resource.

  To add a
  property override, either use `addPropertyOverride` or prefix `path` with
  "Properties." (i.e. `Properties.TopicName`).

  If the override is nested, separate each nested level using a dot (.) in the path parameter.
  If there is an array as part of the nesting, specify the index in the path.

  To include a literal `.` in the property name, prefix with a `\`. In most
  programming languages you will need to write this as `"\\."` because the
  `\` itself will need to be escaped.

  For example,
  ```typescript
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.0.Projection.NonKeyAttributes', ['myattribute']);
  cfnResource.addOverride('Properties.GlobalSecondaryIndexes.1.ProjectionType', 'INCLUDE');
  ```
  would add the overrides
  ```json
  "Properties": {
    "GlobalSecondaryIndexes": [
      {
        "Projection": {
          "NonKeyAttributes": [ "myattribute" ]
          ...
        }
        ...
      },
      {
        "ProjectionType": "INCLUDE"
        ...
      },
    ]
    ...
  }
  ```

  The `value` argument to `addOverride` will not be processed or translated
  in any way. Pass raw JSON values in here with the correct capitalization
  for CloudFormation. If you pass CDK classes or structs, they will be
  rendered with lowercased key names, and CloudFormation will reject the
  template.

  **Parameters**

  - `path` — - The path of the property, you can use dot notation to override values in complex types.
  - `value` — - The value.

- `addPropertyDeletionOverride(propertyPath: string): void` — Adds an override that deletes the value of a property from the resource definition.

  **Parameters**

  - `propertyPath` — The path to the property.

- `addPropertyOverride(propertyPath: string, value: any): void` — Adds an override to a resource property.

  Syntactic sugar for `addOverride("Properties.<...>", value)`.

  **Parameters**

  - `propertyPath` — The path of the property.
  - `value` — The value.

- `addResourceDependency(target: CfnResource, reason?: string): void` — Indicates that this resource depends on another resource and cannot be provisioned unless the other resource has been successfully provisioned.

  This can be used for resources across stacks (or nested stack) boundaries
  and the dependency will automatically be transferred to the relevant scope.

  This method only adds dependencies between L1 resources. If you are
  looking for a generic construct-to-construct dependency mechanism that works
  for all constructs including L2s, use `construct.node.addDependency` instead.

- `applyCrossStackReferenceStrength(strength: ReferenceStrength): void` — Sets the cross-stack reference strength for this resource.

  When set, any cross-stack reference to this resource will use the specified
  strength instead of the global default from the consuming stack's context.

  **Parameters**

  - `strength` — - The reference strength to use for this resource.

- `applyRemovalPolicy(policy?: RemovalPolicy, options?: RemovalPolicyOptions): void` — Sets the deletion policy of the resource based on the removal policy specified.

  The Removal Policy controls what happens to this resource when it stops
  being managed by CloudFormation, either because you've removed it from the
  CDK application or because you've made a change that requires the resource
  to be replaced.

  The resource can be deleted (`RemovalPolicy.DESTROY`), or left in your AWS
  account for data recovery and cleanup later (`RemovalPolicy.RETAIN`). In some
  cases, a snapshot can be taken of the resource prior to deletion
  (`RemovalPolicy.SNAPSHOT`). A list of resources that support this policy
  can be found in the following link:

- `arnForDataSource(resource: IDataSourceRef): string` (static)

- `cfnPropertyName(cdkPropertyName: string): string`

- `getAtt(attributeName: string, typeHint?: ResolutionTypeHint): Reference` — Returns a token for an runtime attribute of this resource.

  Ideally, use generated attribute accessors (e.g. `resource.arn`), but this can be used for future compatibility
  in case there is no generated attribute.

  **Parameters**

  - `attributeName` — The name of the attribute.

- `getMetadata(key: string): any` — Retrieve a value value from the CloudFormation Resource Metadata.

- `inspect(inspector: TreeInspector): void` — Examines the CloudFormation resource and discloses attributes.

  **Parameters**

  - `inspector` — tree inspector to collect and process attributes.

- `isCfnDataSource(x: any): boolean` (static) — Checks whether the given object is a CfnDataSource.

- `isCfnElement(x: any): boolean` (static) — Returns `true` if a construct is a stack element (i.e. part of the synthesized cloudformation template).

  Uses duck-typing instead of `instanceof` to allow stack elements from different
  versions of this library to be included in the same stack.

  **Returns:** The construct as a stack element or undefined if it is not a stack element.

- `isCfnResource(x: any): boolean` (static) — Check whether the given object is a CfnResource.

- `isConstruct(x: any): boolean` (static) — Checks if `x` is a construct.

  Use this method instead of `instanceof` to properly detect `Construct`
  instances, even when the construct library is symlinked.

  Explanation: in JavaScript, multiple copies of the `constructs` library on
  disk are seen as independent, completely different libraries. As a
  consequence, the class `Construct` in each copy of the `constructs` library
  is seen as a different class, and an instance of one class will not test as
  `instanceof` the other class. `npm install` will not create installations
  like this, but users may manually symlink construct libraries together or
  use a monorepo tool: in those cases, multiple copies of the `constructs`
  library can be accidentally installed, and `instanceof` will behave
  unpredictably. It is safest to avoid using `instanceof`, and using
  this type-testing method instead.

  **Parameters**

  - `x` — Any object.

  **Returns:** true if `x` is an object created from a class which extends `Construct`.

- `obtainDependencies(): Stack | CfnResource[]` — Retrieves an array of resources and stacks this resource depends on.

  For resources depended on directly, returns the `CfnResource` object. For
  dependencies on other stacks, returns the `Stack` object. The order of the
  array is not guaranteed.

- `overrideLogicalId(newLogicalId: string): void` — Overrides the auto-generated logical ID with a specific ID.

  **Parameters**

  - `newLogicalId` — The new logical ID to use for this stack element.

- `removeDependency(target: CfnResource): void` — Use `removeResourceDependency` instead

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `removeResourceDependency(target: CfnResource): void` — Indicates that this resource no longer depends on another resource.

  This can be used for resources across stacks (including nested stacks)
  and the dependency will automatically be removed from the relevant scope.

- `replaceDependency(target: CfnResource, newTarget: CfnResource): void` — Replaces one dependency with another.

  **Parameters**

  - `target` — The dependency to replace.
  - `newTarget` — The new dependency to add.

- `toString(): string` — Returns a string representation of this construct.

  **Returns:** a string representation of this resource

- `with(...mixins: IMixin[]): IConstruct` — Applies one or more mixins to this construct.

  Mixins are applied in order. The list of constructs is captured at the
  start of the call, so constructs added by a mixin will not be visited.
  Use multiple `with()` calls if subsequent mixins should apply to added
  constructs.
